@ECHO OFF
SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION
SET debug=n
SET version=6.0522
REM changes:
REM 6.0522: remove a buggy line from 6.0517
REM 6.0517: would not complete if the directory path contained brackets, now fixed
REM 5.0409: error level setting was not working correctly so if error occurred then message: 'el' is not recognised...
REM         also remove registry setting as use of timedicer.hta is no longer recommended
REM 2.1001: add --no-acls to default settings for rdiff-backup
REM 1.1201: copy image files to %APPDATA%\TimeDicer - for html log file display
REM         add a program menu link to the html log file
REM 0.1204: more or less original version
CLS
COLOR 1F
ECHO.
ECHO                       TimeDicer Installer v%version%
ECHO.
NET SESSION >NUL 2>&1
IF ERRORLEVEL 1 (
	ECHO Sorry, this must be run as administrator
	SET el=1
	GOTO :endd
)
PUSHD
SET execpath=%~dp0
SET execpath=%execpath:~0,-1%
IF "%debug%"=="y" ECHO Debug: execpath is %execpath%
SET WINBIT=x86&& IF "%PROCESSOR_ARCHITECTURE%" == "AMD64" (SET WINBIT=x64) ELSE IF "%PROCESSOR_ARCHITEW6432%" == "AMD64" SET WINBIT=x64
IF "%debug%"=="y" ECHO Debug: WINBIT is %WINBIT%
IF %WINBIT%==x64 (SET PROGRAMLOC="%ProgramFiles(x86)%") ELSE (SET PROGRAMLOC="%ProgramFiles%")
FOR %%I IN (%PROGRAMLOC%) DO SET PROGRAMLOC=%%~fsI
IF "%debug%"=="y" ECHO Debug: PROGRAMLOC is %PROGRAMLOC%
ECHO This will ^(re-^)install TimeDicer at %PROGRAMLOC%\TimeDicer.
ECHO To cancel, press CTRL+BREAK, then ENTER, then Y
PAUSE
IF "%debug%"=="y" ECHO Debug: point 1
CD /D %execpath%
IF "%debug%"=="y" ECHO Debug: point 2
IF NOT EXIST "TimeDicer.cmd" (
	IF "%debug%"=="y" ECHO Debug: point 3
	ECHO Sorry, cannot locate TimeDicer.cmd
	SET el=2
	GOTO :endd
)
IF "%debug%"=="y" ECHO Debug: point 6
ECHO Installing, please wait...
MKDIR "%PROGRAMLOC%\TimeDicer" 2>NUL
MKDIR "%APPDATA%\TimeDicer" 2>NUL
COPY /Y *.* "%PROGRAMLOC%\TimeDicer\">NUL
IF ERRORLEVEL 1 ECHO An error occurred copying files to "%PROGRAMLOC%\TimeDicer"&SET el=5&GOTO :endd
COPY /Y "timedice.css" "%APPDATA%\TimeDicer\">NUL
IF ERRORLEVEL 1 ECHO An error occurred copying files to "%APPDATA%\TimeDicer"&SET el=7&GOTO :endd
IF NOT EXIST "%APPDATA%\TimeDicer\timedicer*.png" COPY /Y "timedicer*.png" "%APPDATA%\TimeDicer\">NUL
IF ERRORLEVEL 1 ECHO An error occurred copying files to "%APPDATA%\TimeDicer"&SET el=8&GOTO :endd
IF NOT EXIST "%APPDATA%\TimeDicer\timedicer64x64.ico" COPY /Y "timedicer64x64.ico" "%APPDATA%\TimeDicer\">NUL
IF ERRORLEVEL 1 ECHO An error occurred copying files to "%APPDATA%\TimeDicer"&SET el=9&GOTO :endd
IF NOT EXIST "%APPDATA%\TimeDicer\timedicer-log.html" COPY /Y "timedicer-log-init.html" "%APPDATA%\TimeDicer\timedicer-log.html">NUL
IF ERRORLEVEL 1 ECHO An error occurred copying files to "%APPDATA%\TimeDicer"&SET el=10&GOTO :endd
IF EXIST "%PROGRAMLOC%\TimeDicer\timedicer-log-init.html" DEL "%PROGRAMLOC%\TimeDicer\timedicer-log-init.html"
IF ERRORLEVEL 1 ECHO An error occurred copying files to "%APPDATA%\TimeDicer"&SET el=11&GOTO :endd
SET PPK=N
IF EXIST "%APPDATA%\TimeDicer\privatekey.ppk" SET PPK=Y
IF EXIST "%USERPROFILE%\privatekey.ppk" SET PPK=Y
CALL :MakeShortcut "%PROGRAMLOC%\TimeDicer\TimeDicer.cmd"
CALL :MakeShortcut "%PROGRAMLOC%\TimeDicer\timedicer-man.html"
IF NOT EXIST "%APPDATA%\TimeDicer\timedicer-log.html" ECHO.>"%APPDATA%\TimeDicer\timedicer-log.html"
CALL :MakeShortcut "%APPDATA%\TimeDicer\timedicer-log.html"
REM add entries to registry (for right-click to timedicer.hta)
REM start regedit /s timedicer-%WINBIT%.reg
IF NOT EXIST "%APPDATA%\TimeDicer\TimeDicer.txt" (
	SET /P server="Enter the server address ip if you know it, or just press ENTER: "
	IF "!server:~0,1!"=="!" (SET server==) ELSE SET server==!server!
	ECHO SET server!server!>"%APPDATA%\TimeDicer\TimeDicer.txt"
	ECHO SET excludelist=%APPDATA%\TimeDicer\exclude-filelist.txt>>"%APPDATA%\TimeDicer\TimeDicer.txt"
	ECHO SET options=--no-acls -v5>>"%APPDATA%\TimeDicer\TimeDicer.txt"
	ECHO %USERPROFILE%,userbase>>"%APPDATA%\TimeDicer\TimeDicer.txt"

	IF ERRORLEVEL 1 ECHO An error occurred creating "%APPDATA%\TimeDicer\TimeDicer.txt"&SET el=6&GOTO :endd
	SET user=%USERNAME%-%USERDOMAIN%
	CALL :lcase user
	ECHO TimeDicer was successfully installed.
	ECHO Please make a note of your TimeDicer username: !user!
	ECHO Your initial configuration is at:
	ECHO "%APPDATA%\TimeDicer\TimeDicer.txt"
	ECHO This will be opened for you to edit when you press any key.
	IF %PPK%==N (
		ECHO.
		ECHO Also puttygen will be started for you to create your private/public key
		ECHO combination. Enter the public key at your TimeDicer Server homepage and
		ECHO save the private key at:
		ECHO "%APPDATA%\TimeDicer\privatekey.ppk"
	)
	PAUSE
	"%APPDATA%\TimeDicer\TimeDicer.txt"
) ELSE (
	ECHO TimeDicer was successfully reinstalled, retaining existing configuration:
	ECHO "%APPDATA%\TimeDicer\TimeDicer.txt"
	IF %PPK%==N (
		ECHO.
		ECHO After you press a key, puttygen will start for you to create your private/
		ECHO public key combination. Enter the public key at your TimeDicer Server homepage
		ECHO and save the private key at: "%APPDATA%\TimeDicer\privatekey.ppk"
	)
	PAUSE
)
"%PROGRAMLOC%\TimeDicer\TimeDicer-man.html"
IF %PPK%==N "%PROGRAMLOC%\TimeDicer\puttygen.exe"
:endd
IF "%debug%"=="y" ECHO Debug: point 89
POPD
PAUSE
IF "%debug%"=="y" ECHO Debug: point 90
COLOR
EXIT /B %el%
GOTO :EOF
:LCase
:: Subroutine to convert a variable VALUE to all lower case.
:: The argument for this subroutine is the variable NAME.
IF "%1" EQU "" GOTO :EOF
FOR %%i IN ("A=a" "B=b" "C=c" "D=d" "E=e" "F=f" "G=g" "H=h" "I=i" "J=j" "K=k" "L=l" "M=m" "N=n" "O=o" "P=p" "Q=q" "R=r" "S=s" "T=t" "U=u" "V=v" "W=w" "X=x" "Y=y" "Z=z" " =") DO CALL SET "%1=%%%1:%%~i%%"
GOTO:EOF
:MakeShortcut
SETLOCAL
::For Windows NT 4.0 users only!!!
::Creates LNK and PIF files from the command line.
::Author: Walter Zackery
REM adapted by Dominic, creates shortcuts in Start Menu and Desktop
REM You must pass the path of a file or folder to the batch file as a shortcut target.
(set hkey=HKEY_CURRENT_USER\Software\Microsoft\Windows)
(set hkey=%hkey%\CurrentVersion\Explorer\Shell Folders)
(set inf=rundll32 setupapi,InstallHinfSection DefaultInstall)
REM extract info from registry
start/w regedit /e %temp%\#57#.tmp "%hkey%"
REM extract program name from %1 as supplied
for /f "tokens=*" %%? in ('dir/b/a %1? 2^>nul') do (set name=%%~nx?)
REM for /f "tokens=*" %%? in ('dir/b/a %1? 2^>nul') do (set foldername=%%~n?)
set foldername=TimeDicer
REM extract Desktop (d) and Start Menu Programs (p) paths from registry info
REM registry data is filled with nulls, I use ssed to deal with this and don't bother with findstr...
for /f "tokens=*" %%? in ('ssed -ne "s/\x00//g;/^\x22Desktop\x22/{s/\\\\/\\/g;s/.*=\(.*\)/\1/p}" %temp%\#57#.tmp') do (set d=%%?)
for /f "tokens=*" %%? in ('ssed -ne "s/\x00//g;/^\x22Programs\x22/{s/\\\\/\\/g;s/.*=\(.*\)/\1/p}" %temp%\#57#.tmp') do (set p=%%?)
REM for /f "tokens=2* delims==" %%? in ('findstr/b /i """desktop"""= %temp%\#57#.tmp') do (set d=%%?)
REM for /f "tokens=2* delims==" %%? in ('findstr/b /i """programs"""= %temp%\#57#.tmp') do (set p=%%?)
REM (set d=%d:\\=\%) & (set p=%p:\\=\%)
REM manipulate d (Desktop path) in some way I don't understand...
if not %2[==[ if exist %~fs2\nul (set d=%~fs2)
if not %2[==[ if exist %~fs2nul (set d=%~fs2)
set x=if exist %2\nul
if not %2[==[ if not %d%==%2 %x% if "%~p2"=="\" set d=%2
echo %d%|find ":\" >nul||(set d=%d%\)
REM set file and drive
(set file=""""""%1"""""")
for /f "tokens=1 delims=:" %%? in ("%file:"=%") do set drive=%%?
(set progman=setup.ini, progman.groups,,)
REM create file #k#.inf
echo > %temp%\#k#.inf [version]
echo >>%temp%\#k#.inf signature=$chicago$
echo >>%temp%\#k#.inf [DefaultInstall]
echo >>%temp%\#k#.inf UpdateInis=Addlink
echo >>%temp%\#k#.inf [Addlink]
echo >>%temp%\#k#.inf %progman% ""group200="%foldername%"""
echo >>%temp%\#k#.inf setup.ini, group200,, """%name%"",%file%
REM echo d is %d%, p is %p%, name is %name%, foldername is %foldername%, file is %file%, progman is %progman%, drive is %drive%
REM GOTO :EOF
REM pass #k#.inf to setupapi
start/w %inf% 132 %temp%\#k#.inf
REM remove files no longer needed
del %temp%\#k#.inf %temp%\#57#.tmp
REM copy StartMenu shortcuts to Desktop
copy %p%\"%foldername%\*.*" %d% >nul 2>&1
REM remove StartMenu folder
REM rd %p%\%foldername% 2>nul
REM move StartMenu lnk file to desktop
REM move %p%\%foldername%.lnk %d%\"drive %drive%.lnk" >nul 2>&1
GOTO :EOF
